﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace OvereniPlatnosti
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public class Clovek
    {
        public string Jmeno { get; set; }
        public string Prijmeni { get; set; }
        public int Vek { get; set; }

        public Clovek()
        {
            Jmeno = String.Empty;
            Prijmeni = String.Empty;
            Vek = 0;
        }

        public Clovek(string jmeno, string prijmeni, int vek)
        {
            Jmeno = jmeno;
            Prijmeni = prijmeni;
            Vek = vek;
        }

        public override string ToString()
        {
            return Jmeno + " " + Prijmeni + ", " + Vek;
        }
            
    }

    public class JeCislo : ValidationRule
    {
        public override ValidationResult Validate
                (object value, System.Globalization.CultureInfo cultureInfo)
        {
            int hodnota;
            if (int.TryParse((string)value, out hodnota) && hodnota > 0)
                return ValidationResult.ValidResult;
            else return new ValidationResult(false, "Není číslo");
        }
    }

    public class NeprazdnyRetezec : ValidationRule
    {
        public override ValidationResult Validate
                (object value, System.Globalization.CultureInfo cultureInfo)
        {
            if ((string)value == String.Empty)
                return new ValidationResult(false, "Údaj je nutné vyplnit");
            else return ValidationResult.ValidResult;
        }   
    }

    public partial class HlavniOkno : Window
    {
        private Clovek clovek;

        public HlavniOkno()
        {
            InitializeComponent();

            clovek = new Clovek();
            DataContext = clovek;
        }

        private void btnOdeslat_Click(object sender, RoutedEventArgs e)
        {
            MessageBox.Show("Odeslané údaje: " + clovek.ToString(),
                "Údaje", MessageBoxButton.OK, MessageBoxImage.Information);
        }

        private void txb_TextChanged(object sender, TextChangedEventArgs e)
        {
            btnOdeslat.IsEnabled = !(Validation.GetHasError(txbJmeno) ||
                                     Validation.GetHasError(txbPrijmeni) ||
                                     Validation.GetHasError(txbVek));
        }
    }
}
